/* 
 * LynX Source Materials
 *
 * This source file is a part of PropertiesWindow command-line program.
 * Description for this program can be found in ReadMe.txt.
 *
 * Copyright 09/2010 LynX <_LynX@bk.ru>
 *
 * PropertiesWindow is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * PropertiesWindow is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with PropertiesWindow. If not, see <http://www.gnu.org/licenses/>.
 *
 */

// PropertiesWindow.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include <iostream>
#include "PropertiesWindow.h"
#define MAX_LOADSTRING 100
#include "Shlobj.h"

using namespace std;

// Global Variables:
HINSTANCE hInst;
HWND hPropWnd;
HWND hMainWnd;

TCHAR szTitle[MAX_LOADSTRING];
TCHAR szWindowClass[MAX_LOADSTRING];

// Forward declarations of functions included in this code module:
ATOM MyRegisterClass(HINSTANCE hInstance);
BOOL InitInstance(HINSTANCE, int, LPTSTR);
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);

/*
 * This function returns HWND of "File properties" common dialog box
 * Dialog box must be runned in the same process where this 
 * function will be called.
 */
HWND findPropertiesWindow() {
    HWND hWnd = NULL;
    DWORD processId;
    DWORD curProcessId = GetCurrentProcessId();
 
    while ((hWnd = FindWindowEx(NULL, hWnd, "#32770", NULL)) != NULL) {
        GetWindowThreadProcessId(hWnd, &processId);

        if (curProcessId == processId) {
            //char txt[100];
            //GetWindowText(hWnd, txt, 100);
            //MessageBox(NULL, txt, "found", MB_OK);
            break;
        }
    }

    return hWnd;
}

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
     // TODO: Place code here.
    MSG msg;

    // Initialize global strings
    LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
    LoadString(hInstance, IDC_PROPERTIESWINDOW, szWindowClass, MAX_LOADSTRING);
    MyRegisterClass(hInstance);

    // Perform application initialization:
    if (strlen(lpCmdLine) == 0) {
        MessageBox(NULL, "PropertiesWindow <path>", "Usage", MB_OK);
        return FALSE;
    }

    if (!InitInstance (hInstance, nCmdShow, lpCmdLine)) 
    {
        return FALSE;
    }

    Sleep(2500);
    hPropWnd = findPropertiesWindow();

    while (IsWindow(hPropWnd)) {
        Sleep(1000);
    }

    SendMessage(hMainWnd, WM_CLOSE, 0, 0);

}

//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
    WNDCLASSEX wcex;

    wcex.cbSize = sizeof(WNDCLASSEX); 

    wcex.style = CS_HREDRAW | CS_VREDRAW;
    wcex.lpfnWndProc = (WNDPROC)WndProc;
    wcex.cbClsExtra = 0;
    wcex.cbWndExtra = 0;
    wcex.hInstance = hInstance;
    wcex.hIcon = LoadIcon(hInstance, (LPCTSTR)IDI_PROPERTIESWINDOW);
    wcex.hCursor = LoadCursor(NULL, IDC_ARROW);
    wcex.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
    wcex.lpszMenuName = (LPCTSTR)IDC_PROPERTIESWINDOW;
    wcex.lpszClassName = szWindowClass;
    wcex.hIconSm = LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

    return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow, LPTSTR path)
{
    hInst = hInstance; // Store instance handle in our global variable
    hMainWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPED,
                        CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

    if (!hMainWnd)
    {
        return FALSE;
    }

    //ShowWindow(hMainWnd, nCmdShow);
    //UpdateWindow(hMainWnd);

    int max = strlen(path);
    wchar_t *wpath = new wchar_t[max + 1];
    max = mbstowcs(wpath, path, max);
    wpath[max] = '\0';
    //MessageBoxW(NULL, wpath, wpath, MB_OK);
    BOOL ret = SHObjectProperties(hMainWnd, SHOP_FILEPATH, wpath, NULL);
    delete[] wpath;

    return ret;
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    int wmId, wmEvent;
    PAINTSTRUCT ps;
    HDC hdc;

    switch (message) {
        case WM_DESTROY:
            PostQuitMessage(0);
        break;
    default:
        return DefWindowProc(hWnd, message, wParam, lParam);
    }
    return 0;
}
